/*
 * scnhdr.h
 *
 *	Copyright (C) 1997 by Sony Computer Entertainment
 *			All rights Reserved
 */
#ifndef _SCNHDR_H
#define _SCNHDR_H

struct scnhdr {
	char		s_name[8];	/* section name */
	long		s_paddr;	/* physical address, aliased s_nlib */
	long		s_vaddr;	/* virtual address */
	long		s_size;		/* section size */
	long		s_scnptr;	/* file ptr to raw data for section */
	long		s_relptr;	/* file ptr to relocation */
	long		s_lnnoptr;	/* file ptr to gp histogram */
	unsigned short	s_nreloc;	/* number of relocation entries */
	unsigned short	s_nlnno;	/* number of gp histogram entries */
	long		s_flags;	/* flags */
};

#define SCNROUND ((long)16)
#define s_nlib	s_paddr
#define	SCNHDR	struct scnhdr
#define	SCNHSZ	sizeof(SCNHDR)
#define	_TEXT	".text"
#define	_DATA	".data"
#define	_BSS	".bss"
#define	_TV	".tv"
#define _INIT ".init"
#define _FINI ".fini"
#define _LIB ".lib"

#define	_RDATA	".rdata"
#define	_SDATA	".sdata"
#define	_SBSS	".sbss"
#define _UCODE	".ucode"
#define _LIT8	".lit8"
#define _LIT4	".lit4"



#define STYP_REG	0x00
#define STYP_DSECT	0x01
#define STYP_NOLOAD	0x02
#define STYP_GROUP	0x04
#define STYP_PAD	0x08
#define STYP_COPY	0x10
#define	STYP_TEXT	0x20
#define STYP_DATA	0x40
#define STYP_BSS	0x80

#define STYP_RDATA	0x100
#define STYP_SDATA	0x200
#define STYP_SBSS	0x400
#define STYP_UCODE	0x800
#define STYP_LIT8	0x08000000
#define STYP_LIT4	0x10000000
#define S_NRELOC_OVFL	0x20000000
#define STYP_LIB	0x40000000
#define STYP_INIT	0x80000000
#endif /* _SCNHDR_H */
